const RuntimeError = require('./RuntimeError')
const MSG = {
  '400': '400 Bad Request',
  '401': '401 Authorization Required',
  '402': '402 Payment Required',
  '403': '403 Forbidden',
  '404': '404 Not Found',
  '500': '500 Internal Server Error'
}

class HttpError extends RuntimeError {
  constructor(status, message, cause) {
    super(message || MSG[status], cause)
    this._status = status
  }

  get status() {
    return this._status
  }
}

module.exports = HttpError
