const HttpBody = require('./HttpBody')

module.exports = class HttpForm extends HttpBody {
  constructor(content) {
    super(content, 'application/x-www-form-urlencoded')
  }

  toString() {
    return HttpForm.encode(this.content)
  }

  static encode(obj, buf = '', prefix = '') {
    if (typeof obj === 'object') {
      if (obj instanceof Array) {
        obj.forEach((value, index) => {
          buf = HttpForm.encode(value, buf, prefix + '[' + index + ']')
        })
      } else {
        Object.keys(obj).forEach(key => {
          buf = HttpForm.encode(obj[key], buf, prefix ? prefix + '.' + key : key)
        })
      }
      return buf
    } else {
      let newQuery = prefix + '=' + obj
      return buf ? buf + '&' + newQuery : newQuery
    }
  }
}
