const TaskContext = require('./TaskContext')
const HttpTaskContext = require('./http/HttpTaskContext')

module.exports = class TaskManager {
  constructor(context) {
    this._context = context
  }

  createHttpTaskAdaptor(handler, isTransaction) {
    return (req, res, next) => {
      this.execute(new HttpTaskContext(this, handler, { req, res, next, isTransaction }))
    }
  }

  async createSqlContext() {
    return await this._context.createSqlContext()
  }

  execute(taskContext) {
    setTimeout(taskContext.run.bind(taskContext), 0)
  }

  schedule(task, isTransaction) {
    this.execute(new TaskContext(this, task, isTransaction))
  }
}
