const path = require('path')

module.exports = class Config {
  constructor(runtime) {
    this._runtime = runtime
  }

  set source(source) {
    this._source = source
  }

  get appName() {
    return this._source.appName
  }

  get appPort() {
    return this._source.appPort
  }

  get appStatic() {
    return this.resolvePath(this._source.appStatic || '../static')
  }

  get database() {
    return this._source.database
  }

  resolvePath(target) {
    return path.resolve(this._runtime, target)
  }
}
